﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Reflection;

namespace ORM05
{
    class DbFieldReader
    {
        private static MethodInfo getValueMethod = typeof(DbFieldReader).GetMethods().Where(c => c.Name == "GetValue" && c.IsGenericMethod).First();
        private IDataReader reader;
        public DbFieldReader(IDataReader reader)
        {
            this.reader = reader;
        }

        public T GetValue<T>(int index)
        {
            object value = reader.GetValue(index);

            if (value == DBNull.Value)
                return default(T);

            return (T)reader.GetValue(index);
        }

        public static MethodInfo GetValueMethod(Type type)
        {
            return getValueMethod.MakeGenericMethod(type);
        }
    }
}