﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace ORM05
{
    class DbProvider
    {
        private IDbConnection conntion;
        public DbProvider(IDbConnection conntion)
        {
            this.conntion = conntion;
        }

        public virtual int ExecuteNonQuery(string sql, Dictionary<string, object> parameters)
        {
            var wasClosed = this.conntion.State == ConnectionState.Closed;
            try
            {
                var cmd = this.conntion.CreateCommand();
                cmd.CommandText = sql;
                foreach (var item in parameters)
                {
                    var pa = cmd.CreateParameter();
                    pa.ParameterName = item.Key;
                    pa.Value = item.Value ?? DBNull.Value;
                    cmd.Parameters.Add(pa);
                }

                if (wasClosed) this.conntion.Open();
                return cmd.ExecuteNonQuery();
            }
            finally
            {
                if (wasClosed) this.conntion.Close();
            }
        }
        public virtual IDataReader ExecuteReader(string sql, Dictionary<string, object> parameters)
        {
            var wasClosed = this.conntion.State == ConnectionState.Closed;
            try
            {
                var cmd = this.conntion.CreateCommand();
                cmd.CommandText = sql;
                if (parameters != null && parameters.Count > 0)
                {
                    foreach (var item in parameters)
                    {
                        var pa = cmd.CreateParameter();
                        pa.ParameterName = item.Key;
                        pa.Value = item.Value ?? DBNull.Value;
                        cmd.Parameters.Add(pa);
                    }
                }
                if (wasClosed) this.conntion.Open();
                return cmd.ExecuteReader(CommandBehavior.CloseConnection);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

    }
}